<template>
  <div id="index">
    <admin-frame @search="search" :limit="limit" :total="total" topType="2" @back="back" :rightArrow="false" :useNav="false">
      <template v-slot:info>
        <list-1 :list="list" @toView="toView" @toCheck="toCheck" @toFile="toFile"></list-1>
      </template>
    </admin-frame>
    <van-dialog class="dialog" v-model="dialog.show" :title="dialog.title" :show-confirm-button="false" show-cancel-button cancel-button-text="返回">
      <info-1 :info="info" v-if="dialog.type == '1'"></info-1>
      <check-1 :form="info" v-else-if="dialog.type == '2'" @onSubmit="oneSubmit"></check-1>
      <file-1 :form="info" v-else-if="dialog.type == '3'" @onSubmit="twoSubmit"></file-1>
    </van-dialog>
  </div>
</template>

<script>
import list1 from '@/layout/assessment/list-1.vue';
import info1 from '@/layout/assessment/info-1.vue';
import check1 from '@/layout/assessment/check-1.vue';
import file1 from '@/layout/assessment/file-1.vue';
import adminFrame from '@frame/src/components/mobile-frame/mobile-main.vue';
import { mapState, createNamespacedHelpers } from 'vuex';
const { mapActions: patentassess } = createNamespacedHelpers('patentassess');
export default {
  name: 'index',
  props: {},
  components: {
    adminFrame,
    list1,
    info1,
    check1,
    file1,
  },
  data: function () {
    return {
      active: 0,
      list: [],
      limit: 4,
      total: 0,
      // 弹框
      dialog: { show: false, title: '详细信息', type: '1' },
      // 详细信息
      info: {},
    };
  },
  created() {
    this.search();
  },
  methods: {
    ...patentassess(['query', 'fetch', 'check']),
    async search({ skip = 0, limit = this.limit, ...info } = {}) {
      let res = await this.query({ skip, limit, ...info });
      if (this.$checkRes(res)) {
        this.$set(this, `list`, res.data);
        this.$set(this, `total`, res.total);
      }
    },
    // 详细信息
    async toView(data) {
      let res = await this.fetch(data.id);
      if (this.$checkRes(res)) {
        this.$set(this, `info`, res.data);
        this.dialog = { show: true, title: '详细信息', type: '1' };
      }
    },
    // 审核申请
    toCheck(data) {
      this.$set(this, `info`, data);
      this.dialog = { show: true, title: '审核申请', type: '2' };
    },
    // 提交审核
    async oneSubmit(data) {
      let res = await this.check(data);
      if (this.$checkRes(res)) {
        this.$toast({ type: `success`, message: `操作成功` });
        this.search();
        this.dialog = { show: false, title: '审核申请', type: '2' };
      }
    },
    // 报告文件
    toFile(data) {
      this.$set(this, `info`, data);
      this.dialog = { show: true, title: '报告文件', type: '3' };
    },
    // 提交报告文件
    async twoSubmit(data) {
      let res = await this.check(data);
      if (this.$checkRes(res)) {
        this.$toast({ type: `success`, message: `操作成功` });
        this.search();
        this.dialog = { show: false, title: '报告文件', type: '3' };
      }
    },
    // 返回
    back() {
      this.$router.push({ path: '/patent/index' });
    },
  },
  computed: {
    ...mapState(['user']),
  },
  metaInfo() {
    return { title: this.$route.meta.title };
  },
  watch: {
    active: {
      deep: true,
      immediate: true,
      handler(val) {
        this.search();
      },
    },
  },
};
</script>

<style lang="less" scoped>
.dialog {
  /deep/.van-dialog__content {
    max-height: 350px;
    overflow-y: auto;
  }
}
</style>
